//By DrenDran BL_ID 22749
//Second release, 3/28/2016

$supportBinaryLoaded = true;

$binaryFileBufferSize = 1024;
$asciimap =     "\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0A\x0B\x0C\x0D\x0E\x0F" @
        "\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1A\x1B\x1C\x1D\x1E\x1F" @
        "\x20\x21\x22\x23\x24\x25\x26\x27\x28\x29\x2A\x2B\x2C\x2D\x2E\x2F" @
        "\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\x3A\x3B\x3C\x3D\x3E\x3F" @
        "\x40\x41\x42\x43\x44\x45\x46\x47\x48\x49\x4A\x4B\x4C\x4D\x4E\x4F" @
        "\x50\x51\x52\x53\x54\x55\x56\x57\x58\x59\x5A\x5B\x5C\x5D\x5E\x5F" @
        "\x60\x61\x62\x63\x64\x65\x66\x67\x68\x69\x6A\x6B\x6C\x6D\x6E\x6F" @
        "\x70\x71\x72\x73\x74\x75\x76\x77\x78\x79\x7A\x7B\x7C\x7D\x7E\x7F" @
        "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F" @
        "\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F" @
        "\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF" @
        "\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF" @
        "\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF" @
        "\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF" @
        "\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF" @
       	"\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF";

function ord(%char)
{
	if(strlen(%char) > 1)
	{
		error("ord(" @ %char @ ") -- string longer than one character.");
		return 0;
	}
	return strPos($asciimap,%char)+1;
}

function chr(%ord)
{
	if(%ord < 1)
	{
		error("chr(" @ %ord @ ") -- character less than 1.");
		return 1;
	}
	if(%ord > 255)
	{
		error("chr(" @ %ord @ ") -- character greater than 255.");
		return 1;
	}
	return getSubStr($asciimap,%ord-1,1);
}

function openBinaryFileForWrite(%fileName)
{
	%tmpObj = new FileObject();
	%ret = %tmpObj.openForWrite(%fileName);
	if(!%ret)
		return 0;

	%newObj = new ScriptObject()
	{
		class = binaryFile;
		path = %fileName;
		fileObject = %tmpObj;
		mode = 1;
		buffer = "";
		bufferSize = $binaryFileBufferSize;
		byteBuffer = 0;
		byteBufferPos = 0;
	};

	return %newObj;
}

function openBinaryFileForRead(%fileName)
{
	%tmpObj = new FileObject();
	%ret = %tmpObj.openForRead(%fileName);
	if(!%ret)
		return 0;

	%newObj = new ScriptObject()
	{
		class = binaryFile;
		path = %fileName;
		fileObject = %tmpObj;
		mode = 2;
		pointer = $binaryFileBufferSize;
		buffer = "";
		bufferEOF = 0;
		eof = 0;
		byteBuffer = 0;
		byteBufferPos = 0;
	};

	%newObj.byteBuffer = %newObj.read();

	return %newObj;
}

function binaryFile::write(%file,%number)
{
	if(%number < 0)
	{
		error("ERROR: write(" @ %file @ "," @ %number @ ") number is less than 0.");
		%number = 0;
		error($lastWrittenBin);
	}
	if(%number > 255)
	{
		error("ERROR: write(" @ %file @ "," @ %number @ ") number is greater than 255.");
		%number = 255;
	}

	%char = -50;

	if(%number == 0)
	{
		%char = "\xFF\xFD";
	}
	else if(%number == 10)
	{
		%char = "\xFF\xFE";
	}
	else if(%number == 13)
	{
		%char = "\xFF\xFC";
	}
	else if(%number == 255)
	{
		%char = "\xFF\xFF";
	}
	else
	{
		//%eval = "%char = \"\\x" @ decToHex(%number) @ "\";";
		//eval(%eval);
		%char = chr(%number);
	}

	if(%char != -50)
	{
		if(!isObject(%file))
		{
			error("ERROR: write(" @ %file @ "," @ %number @ ") Invalid binary file.");
			return;
		}
		if(!isObject(%file.fileObject))
		{
			error("ERROR: write(" @ %file @ "," @ %number @ ") File not open.");
			return;
		}
		%file.buffer = %file.buffer @ %char;
		if(strlen(%file.buffer) >= %file.bufferSize)
		{
			%file.fileObject.writeLine(%file.buffer);
			%file.buffer = "";
		}
	}
	else
	{
		error("ERROR: write(" @ %file @ "," @ %number @ ") character returned 0.");
		return;
	}
}

function binaryFile::read(%file,%re)
{
	if(%file.bufferEOF)
	{
		error("ERROR: read(" @ %file @ "," @ %re @ ") -- EOF");
		return -1;
	}

	if(%file.pointer > strlen(%file.buffer) - 1)
	{
		//warn("Reading new line.");
		%file.buffer = %file.fileObject.readLine();
		if(strLen(%file.buffer) < 1)
		{
			%file.bufferEOF = true;
			error("ERROR: read(" @ %file @ ") End of file.");
			return -1;
		}
		if(strLen(%file.buffer) < 128)
		{
			%file.lastBuffer = true; 
		}
		%file.pointer = 1;
		%char = getSubStr(%file.buffer,0,1);
		%ord = ord(%char);

		if(%ord == 255)
		{
			if(%re)
			{
				return 255;
			}
			%nextord = %file.read(true);
			if(%nextord == 255)
				return 255;
			else if(%nextord == 251)
			{
				%file.bufferEOF = true;
				return -1;
			}
			else if(%nextord == 254)
				return 10;
			else if(%nextord == 253)
				return 0;
			else if(%nextord == 252)
				return 13;
			else
			{
				error("ERROR: read(" @ %file @ ",1) -- Invalid number sequence in file! (2," @ %nextord @ ")");
				return 0;
			}
		}
		else
			return %ord;
	}
	else
	{
		%file.pointer++;

		if(%file.pointer > strlen(%file.buffer)-3 && %file.lastBuffer)
			%file.bufferEOF = true;

		%char = getSubStr(%file.buffer,%file.pointer-1,1);
		%ord = ord(%char);

		if(%ord == 255)
		{
			if(%re)
			{
				return 255;
			}
			%nextord = %file.read(true);
			if(%nextord == 255)
				return 255;
			else if(%nextord == 251)
			{
				%file.bufferEOF = true;
				return -1;
			}
			else if(%nextord == 254)
				return 10;
			else if(%nextord == 253)
				return 0;
			else if(%nextord == 252)
				return 13;
			else
			{
				error("ERROR: read(" @ %file @ ",1) -- Invalid number sequence in file! (3," @ %nextord @ ")");
				return 0;
			}
		}
		else
			return %ord;
	}
}

function binaryFile::writeBit(%file,%boolean)
{
	if(%file.byteBufferPos == 8)
	{
		%file.write(%file.byteBuffer);
		%file.byteBuffer = 0;
		%file.byteBufferPos = 0;		
	}
	if(%boolean)
		%file.byteBuffer = %file.byteBuffer | mpow(2,%file.byteBufferPos);
	%file.byteBufferPos++;
}

function binaryFile::writeNumBits(%file,%theByte,%bits)
{
	for(%a=0;%a<%bits;%a++)
		%file.writeBit(%theByte & mpow(2,%a));
}

function binaryFile::readNumBits(%file,%bits)
{
	%ret = 0;
	for(%a=0;%a<%bits;%a++)
		if(%file.readBit())
			%ret += mpow(2,%a);
	return %ret;
}

function binaryFile::finishByte(%file)
{
	if(%file.byteBufferPos == 0)
		return;
	%file.write(%file.byteBuffer);
	%file.byteBuffer = 0;
	%file.byteBufferPos = 0;
}

function binaryFile::readBit(%file)
{
	if(%file.byteBufferPos == 8)
	{
		%file.byteBufferPos = 0;
		%file.byteBuffer = %file.read();
	}
	if(%file.byteBuffer < 0)
	{
		error("Hit EOF in binaryFile::readBit");
		%file.eof = true;
		return 0;
	}
	%ret = %file.byteBuffer & mpow(2,%file.byteBufferPos);
	%file.byteBufferPos++;
	%file.eof = %file.bufferEOF && %file.byteBufferPos > 6;
	if(%ret)
		return true;
	else
		return false;
}

function binaryFile::close(%file)
{
	if(%file.mode == 2)
	{
		%file.fileObject.close();
		%file.delete();
		return;
	}

	if(isObject(%file))
	{
		if(isObject(%file.fileObject))
		{
			%file.finishByte();

			%file.buffer = %file.buffer @ "\xFF\xFB";
			if(strlen(%file.buffer) >= %file.bufferSize)
			{
				%file.fileObject.writeLine(%file.buffer);
				%file.buffer = "";
			}

			if(strlen(%file.buffer))
			{
				%file.fileObject.writeLine(%file.buffer);
			}
		}
	}
	%file.fileObject.close();
	%file.fileObject.delete();
	%file.delete();
	return 1;
}

function isSixBitString(%string)
{
	return stripChars(%string,"abcdefghijklmnopqrstuvwxyz_0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ") $= "";
}

function sixBitValue(%char)
{
	%or = %char;
	if(%or == 95)
		return 1; //2
	else if(%or >= 97 && %or <= 122)
		return %or-95; //28
	else if(%or >= 65 && %or <= 90)
		return %or-37;	//54
	else if(%or >= 48 && %or <= 57)
		return %or+6;
	else
		error("sixBitValue(%char) %char was" SPC %char SPC " INVALID");
}

function valueBitSix(%char)
{
	%or = %char;
	if(%or == 0)
		return 0;
	if(%or == 1)
		return 95;
	if(%or >= 2 && %or <= 27)
		return %or+95;
	if(%or >= 28 && %or <= 53)
		return %or+37;
	if(%or >= 54 && %or <= 63)
		return %or-6;
	error("valueBitSix(%char) %char was" SPC %char SPC " INVALID");
}

function binaryFile::writeString(%file,%string)
{
	if(isSixBitString(%string))
	{
		%file.writeBit(true);
		%file.writeBit(true);
		%file.writeBit(false);

		for(%a=0;%a<strlen(%string);%a++)	
			%file.writeNumBits(sixBitValue(ord(getSubStr(%string,%a,1))),6);

		%file.writeNumBits(0,6);	
	}
	else
	{
		%file.writeBit(true);
		%file.writeBit(true);
		%file.writeBit(true);

		for(%a=0;%a<strlen(%string);%a++)
			%file.writeNumBits(ord(getSubStr(%string,%a,1)),8);
		
		%file.writeNumBits(0,8);
	}
}

function isInteger(%var)
{
	return stripChars(%var, "-0123456789") $= "";
}

function binaryFile::writeNumber(%file,%number)
{
	if(mabs(%number) < 256)
	{
		if(isInteger(%number))
		{
			%file.writeBit(true);
			%file.writeBit(false);
			%file.writeBit(false);

			%file.writeBit(%number<0);
			%number = mabs(%number);

			for(%a=0;%a<8;%a++)
				%file.writeBit(%number & mpow(2,%a));

			return;
		}
		else
		{
			%file.writeBit(true);
			%file.writeBit(false);
			%file.writeBit(true);

			%file.writeBit(%number<0);
			%number = mabs(%number);

			%whole = mfloor(%number);
			%decimal = %number-%whole;
			%decimal *= 100;
			%decimal = mFloor(%decimal+0.5);

			for(%a=0;%a<8;%a++)
				%file.writeBit(%whole & mpow(2,%a));


			for(%a=0;%a<7;%a++)
				%file.writeBit(%decimal & mpow(2,%a));

			return;	
		}		
	}
	else if(mabs(%number) < 32767)
	{
		if(isInteger(%number))
		{
			%file.writeBit(false);
			%file.writeBit(true);
			%file.writeBit(false);

			%file.writeBit(%number<0);
			%number = mabs(%number);

			for(%a=0;%a<15;%a++)
				%file.writeBit(%number & mpow(2,%a));

			return;
		}
		else
		{
			%file.writeBit(false);
			%file.writeBit(true);
			%file.writeBit(true);

			%file.writeBit(%number<0);
			%number = mabs(%number);

			%whole = mfloor(%number);
			%decimal = %number-%whole;
			%decimal *= 100;
			%decimal = mFloor(%decimal+0.5);

			for(%a=0;%a<15;%a++)
				%file.writeBit(%whole & mpow(2,%a));


			for(%a=0;%a<7;%a++)
				%file.writeBit(%decimal & mpow(2,%a));

			return;	
		}
	}
	else if(mabs(%number) < 8388607)
	{
		if(isInteger(%number))
		{
			%file.writeBit(false);
			%file.writeBit(false);
			%file.writeBit(false);

			%file.writeBit(%number<0);
			%number = mabs(%number);

			for(%a=0;%a<23;%a++)
				%file.writeBit(%number & mpow(2,%a));

			return;
		}
		else
		{
			%file.writeBit(false);
			%file.writeBit(false);
			%file.writeBit(true);

			%file.writeBit(%number<0);
			%number = mabs(%number);

			%whole = mfloor(%number);
			%decimal = %number-%whole;
			%decimal *= 100;
			%decimal = mFloor(%decimal+0.5);

			for(%a=0;%a<23;%a++)
				%file.writeBit(%whole & mpow(2,%a));


			for(%a=0;%a<7;%a++)
				%file.writeBit(%decimal & mpow(2,%a));

			return;	
		}
	}

	error("Invalid number type for file::writeNumber: " @ %number);
}

function binaryFile::readNextObject(%file)
{
	%a = %file.readBit();
	%b = %file.readBit();
	%c = %file.readBit();

	if(%a && %b && !%c)
	{
		%str = "";
		%val = %file.readNumBits(6);
		while(%val != 0)
		{
			%str = %str @ chr(valueBitSix(%val));
			%val = %file.readNumBits(6);	
		}
		return %str;
	}
	else if(%a && %b && %c)
	{
		%str = "";
		%val = %file.readNumBits(8);
		while(%val != 0)
		{
			%str = %str @ chr(%val);
			%val = %file.readNumBits(8);	
		}
		return %str;		
	}
	else if(%a && !%b && !%c)
	{
		%sign = %file.readBit();
		%ret = 0;
		for(%a=0;%a<8;%a++)
			if(%file.readBit())
				%ret += mpow(2,%a);
		if(%sign)
			%ret = 0-%ret;
		return %ret;
	}
	else if(%a && !%b && %c)
	{
		%sign = %file.readBit();
		%ret = 0;
		for(%a=0;%a<8;%a++)
			if(%file.readBit())
				%ret += mpow(2,%a);
		%dec = 0;
		for(%a=0;%a<7;%a++)
			if(%file.readBit())
				%dec += mpow(2,%a);
		%dec /= 100;
		%ret += %dec;
		if(%sign)
			%ret = 0-%ret;
		return %ret;
	}
	else if(!%a && !%b && !%c)
	{
		%sign = %file.readBit();
		%ret = 0;
		for(%a=0;%a<23;%a++)
			if(%file.readBit())
				%ret += mpow(2,%a);
		if(%sign)
			%ret = 0-%ret;
		return %ret;		
	}
	else if(!%a && !%b && %c)
	{
		%sign = %file.readBit();
		%ret = 0;
		for(%a=0;%a<23;%a++)
			if(%file.readBit())
				%ret += mpow(2,%a);
		%dec = 0;
		for(%a=0;%a<7;%a++)
			if(%file.readBit())
				%dec += mpow(2,%a);
		%dec /= 100;
		%ret += %dec;
		if(%sign)
			%ret = 0-%ret;
		return %ret;
	}
	else if(!%a && %b && !%c)
	{
		%sign = %file.readBit();
		%ret = 0;
		for(%a=0;%a<15;%a++)
			if(%file.readBit())
				%ret += mpow(2,%a);
		if(%sign)
			%ret = 0-%ret;
		return %ret;		
	}
	else if(!%a && %b && %c)
	{
		%sign = %file.readBit();
		%ret = 0;
		for(%a=0;%a<15;%a++)
			if(%file.readBit())
				%ret += mpow(2,%a);
		%dec = 0;
		for(%a=0;%a<7;%a++)
			if(%file.readBit())
				%dec += mpow(2,%a);
		%dec /= 100;
		%ret += %dec;
		if(%sign)
			%ret = 0-%ret;
		return %ret;
	}
}

function newTest()
{
	$out = openBinaryFileForWrite("config/testbin.bin");
	if(!$out)
		return;
	$out.writeString("this_is_a_test");
	$out.writeString("And so is this.");
	$out.writeNumber(400.75);
	$out.writeNumber(-400.25);
	$out.writeNumber(40000);
	$out.writeNumber(-40000);
	$out.writeNumber(40000.25);
	$out.writeNumber(-40000.75);
	$out.writeNumber(10000);
	$out.writeNumber(-10000);
	$out.writeNumber(10000.75);
	$out.writeNumber(-10000.25);
	$out.close();
	
	$in = openBinaryFileForRead("config/testbin.bin");
	if(!$in)
		return;
	echo($in.readNextObject());
	echo($in.readNextObject());
	echo($in.readNextObject());
	echo($in.readNextObject());
	echo($in.readNextObject());
	echo($in.readNextObject());
	echo($in.readNextObject());
	echo($in.readNextObject());
	echo($in.readNextObject());
	echo($in.readNextObject());
	$in.close();	
}

function test()
{
	$out = openBinaryFileForWrite("config/testbin.bin");
	if(!$out)
		return;
	$out.writeBit(true);
	$out.writeBit(true);
	$out.writeBit(true);
	$out.writeBit(false);
	$out.writeBit(false);
	$out.writeBit(false);
	$out.writeBit(true);
	$out.writeBit(false);
	$out.writeBit(false);
	$out.writeBit(false);
	$out.writeBit(false);
	$out.writeBit(true);
	$out.writeBit(true);
	$out.writeBit(true);
	$out.writeBit(true);
	$out.writeBit(false);
	$out.writeBit(true);
	$out.writeBit(false);
	$out.writeBit(true);
	$out.writeBit(false);
	$out.writeBit(true);
	$out.writeBit(false);
	$out.writeBit(true);
	$out.close();

	$in = openBinaryFileForRead("config/testbin.bin");
	if(!$in)
		return;
	while(!$in.eof)
		echo($in.readBit());
	$in.close();
}








